"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = LoadableContext;

var _react = require("react");

var React = _interopRequireWildcard(_react);

var _provider = require("./provider");

var _provider2 = _interopRequireDefault(_provider);

var _direct = require("./consumer/direct");

var _direct2 = _interopRequireDefault(_direct);

var _directLoading = require("./consumer/directLoading");

var _directLoading2 = _interopRequireDefault(_directLoading);

var _raw = require("./consumer/raw");

var _raw2 = _interopRequireDefault(_raw);

var _rawLoading = require("./consumer/rawLoading");

var _rawLoading2 = _interopRequireDefault(_rawLoading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function LoadableContext(_ref) {
  var loader = _ref.loader,
      loading = _ref.loading,
      timeOut = _ref.timeOut,
      delay = _ref.delay;

  var _React$createContext = React.createContext(),
      RawProvider = _React$createContext.Provider,
      RawConsumer = _React$createContext.Consumer;

  var Provider = function Provider(props) {
    return React.createElement(_provider2.default, _extends({
      provider: RawProvider,
      loader: loader,
      timeOut: timeOut,
      delay: delay
    }, props));
  };
  var ConsumerDirect = function ConsumerDirect(props) {
    return React.createElement(_direct2.default, _extends({ consumer: RawConsumer }, props));
  };
  var ConsumerDirectLoading = function ConsumerDirectLoading(props) {
    return React.createElement(_directLoading2.default, _extends({
      consumer: RawConsumer,
      loading: loading
    }, props));
  };
  var ConsumerRaw = function ConsumerRaw(props) {
    return React.createElement(_raw2.default, _extends({ consumer: RawConsumer }, props));
  };
  var ConsumerRawLoading = function ConsumerRawLoading(props) {
    return React.createElement(_rawLoading2.default, _extends({
      consumer: RawConsumer,
      loading: loading
    }, props));
  };
  return {
    Provider: Provider,
    Consumer: ConsumerDirect,
    ConsumerLoading: ConsumerDirectLoading,
    ConsumerDirect: ConsumerDirect,
    ConsumerDirectLoading: ConsumerDirectLoading,
    ConsumerRaw: ConsumerRaw,
    ConsumerRawLoading: ConsumerRawLoading
  };
}