"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = LoadingRetryButton;

var _react = require("react");

var React = _interopRequireWildcard(_react);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function LoadingRetryButton(props) {
  if (props.loading) {
    // Nominal loading is going on
    if (props.timedOut) {
      // Timeout, user may want to retry
      return React.createElement(
        "button",
        { onClick: props.retry },
        "Retry"
      );
    } else if (props.pastDelay) {
      // Displaying the loading indicator
      return null;
    } else {
      // Displaying a skeleton component
      return null;
    }
  } else if (props.error !== null && props.error !== undefined && props.error.toString !== null && props.error.toString !== undefined) {
    // An error happenned
    return React.createElement(
      "div",
      null,
      props.error.toString(),
      React.createElement(
        "button",
        { onClick: props.retry },
        "Retry"
      )
    );
  } else {
    // What ? This should not happen
    throw new Error("This should not happen, but react loadable context sent wrong props to loading component");
  }
}