"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var React = _interopRequireWildcard(_react);

var _delay = require("../utils/delay");

var _delay2 = _interopRequireDefault(_delay);

var _isPromise = require("../utils/isPromise");

var _isPromise2 = _interopRequireDefault(_isPromise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Provider = function (_React$Component) {
  _inherits(Provider, _React$Component);

  function Provider(props) {
    _classCallCheck(this, Provider);

    var _this = _possibleConstructorReturn(this, (Provider.__proto__ || Object.getPrototypeOf(Provider)).call(this, props));

    _this.startLoading = _this._startLoading.bind(_this);
    _this.setData = _this._setData.bind(_this);
    _this.getData = _this._getData.bind(_this);
    _this.loadLoader = _this._loadLoader.bind(_this);
    _this.manageDelay = _this._manageDelay.bind(_this);
    _this.manageTimeOut = _this._manageTimeOut.bind(_this);
    _this.state = {
      data: null,
      error: null,
      timedOut: false,
      pastDelay: false
    };
    _this.mounted = false;
    return _this;
  }

  _createClass(Provider, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.mounted = true;
      this.startLoading();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted = false;
    }
  }, {
    key: "_setData",
    value: function _setData(data) {
      this.setState({
        data: data,
        error: null,
        timedOut: false,
        pastDelay: false
      });
    }
  }, {
    key: "_getData",
    value: function _getData() {
      return this.state.data;
    }
  }, {
    key: "_startLoading",
    value: function _startLoading() {
      if (this.mounted) {
        this.setState({
          data: null,
          error: null,
          timedOut: false,
          pastDelay: false
        });
        this.loadLoader();
        this.manageDelay();
        this.manageTimeOut();
      }
    }
  }, {
    key: "_loadLoader",
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var loadee, loaded;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                loadee = this.props.loader(this.props);
                loaded = void 0;

                if (!(0, _isPromise2.default)(loadee)) {
                  _context.next = 9;
                  break;
                }

                _context.next = 6;
                return loadee;

              case 6:
                loaded = _context.sent;
                _context.next = 10;
                break;

              case 9:
                loaded = loadee;

              case 10:
                if (this.mounted) {
                  this.setState({ data: loaded });
                }
                _context.next = 16;
                break;

              case 13:
                _context.prev = 13;
                _context.t0 = _context["catch"](0);

                if (this.mounted) {
                  this.setState({ error: _context.t0 });
                }

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 13]]);
      }));

      function _loadLoader() {
        return _ref.apply(this, arguments);
      }

      return _loadLoader;
    }()
  }, {
    key: "_manageDelay",
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return (0, _delay2.default)(this.props.delay);

              case 2:
                if (!(this.state.data !== null && this.state.data !== undefined)) {
                  _context2.next = 6;
                  break;
                }

                return _context2.abrupt("return");

              case 6:
                if (this.mounted) {
                  this.setState({ pastDelay: true });
                }

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _manageDelay() {
        return _ref2.apply(this, arguments);
      }

      return _manageDelay;
    }()
  }, {
    key: "_manageTimeOut",
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return (0, _delay2.default)(this.props.timeOut);

              case 2:
                if (!(this.state.data !== null && this.state.data !== undefined)) {
                  _context3.next = 6;
                  break;
                }

                return _context3.abrupt("return");

              case 6:
                if (this.mounted) {
                  this.setState({ timedOut: true });
                }

              case 7:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function _manageTimeOut() {
        return _ref3.apply(this, arguments);
      }

      return _manageTimeOut;
    }()
  }, {
    key: "render",
    value: function render() {
      // if (this.state.data !== null && this.state.data !== undefined) {
      var _props = this.props,
          Provider = _props.provider,
          children = _props.children;
      var _state = this.state,
          data = _state.data,
          error = _state.error,
          timedOut = _state.timedOut,
          pastDelay = _state.pastDelay;

      return React.createElement(
        Provider,
        {
          value: {
            data: data,
            error: error,
            timedOut: timedOut,
            pastDelay: pastDelay,
            loading: !(data !== undefined && data !== null) && !(error !== undefined && error !== null),
            retry: this.startLoading,
            setData: this.setData,
            getData: this.getData
          }
        },
        children
      );
    }
  }]);

  return Provider;
}(React.Component);

Provider.defaultProps = {
  delay: 300,
  timeOut: 30000,
  loading: function loading() {
    return null;
  }
};
exports.default = Provider;